﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace howto_is_file_locked
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            txtFileName.Text = Application.ExecutablePath;
            cboAccess.SelectedIndex = 0;
        }

        private void btnIsLocked_Click(object sender, EventArgs e)
        {
            FileAccess file_access;
            switch (cboAccess.Text)
            {
                case "Read":
                    file_access = FileAccess.Read;
                    break;
                case "Write":
                    file_access = FileAccess.Write;
                    break;
                default:
                    file_access = FileAccess.ReadWrite;
                    break;
            }
            if (FileIsLocked(txtFileName.Text, file_access))
            {
                MessageBox.Show("Locked");
            }
            else
            {
                MessageBox.Show("Not locked");
            }
        }

        // Return true if the file is locked for the indicated access.
        private bool FileIsLocked(string filename, FileAccess file_access)
        {
            // Try to open the file with the indicated access.
            try
            {
                FileStream fs = new FileStream(filename, FileMode.Open, file_access);
                fs.Close();
                return false;
            }
            catch (IOException)
            {
                return true;
            }
            catch (Exception)
            {
                throw;
            }
        }
    }
}
